package org.vendor.preferences;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.WorkbenchEncoding;
import org.vendor.preferences.Messages;

public class BurnState {
  public static final org.vendor.preferences.BurnState INSTANCE = new org.vendor.preferences.BurnState();
  
  private File partitionPath;
  
  private String partitionContent;
  
  private File emmcParitionPath;
  
  private String emmcPartitionContent;
  
  public String getPartionContent() {
    return this.partitionContent;
  }
  
  public void setPartitionContent(String partionContent) {
    this.partitionContent = partionContent;
  }
  
  public String getEmmcPartitionContent() {
    return this.emmcPartitionContent;
  }
  
  public void setEmmcPartitionContent(String emmcPartitionContent) {
    this.emmcPartitionContent = emmcPartitionContent;
  }
  
  public void clear() {
    clearEmmcPartition();
    clearPartition();
  }
  
  public void clearEmmcPartition() {
    setEmmcParitionPath(null);
    setEmmcPartitionContent(null);
  }
  
  public void clearPartition() {
    setPartitionContent(null);
    setPartitionPath(null);
  }
  
  public boolean needToSave() {
    if (getPartionContent() == null && getEmmcPartitionContent() == null)
      return false; 
    return true;
  }
  
  public int promptToSave(boolean canCancel) {
    int open = 0;
    if (!needToSave())
      return open; 
    IWorkbenchWindow activeWorkbenchWindow = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
    Shell shell = activeWorkbenchWindow.getShell();
    try {
      if (getPartionContent() != null) {
        boolean openConfirm = MessageDialog.openConfirm(shell, "BurnTool", Messages.Burn_Whether_to_save_partitions);
        if (openConfirm)
          savePartitionTable(getPartitionPath(), getPartionContent()); 
      } 
    } catch (IOException e) {
      e.printStackTrace();
    } finally {
      clearPartition();
    } 
    try {
      if (getEmmcPartitionContent() != null) {
        boolean openConfirm = MessageDialog.openConfirm(shell, "BurnTool", Messages.Burn_Whether_to_save_emmc_partitions);
        if (openConfirm)
          savePartitionTable(getEmmcParitionPath(), 
              getEmmcPartitionContent()); 
      } 
    } catch (IOException e) {
      e.printStackTrace();
    } finally {
      clearEmmcPartition();
    } 
    return open;
  }
  
  protected void savePartitionTable(File file, String content) throws IOException {
    Shell shell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();
    FileDialog fileDialog = new FileDialog(shell, 8192);
    if (file != null)
      fileDialog.setFilterPath(file.getCanonicalPath()); 
    fileDialog.setFilterExtensions(new String[] { "*.xml" });
    String open = fileDialog.open();
    if (open != null) {
      File target = new File(open);
      FileOutputStream out = null;
      try {
        out = new FileOutputStream(target);
        out.write(content.getBytes(WorkbenchEncoding.getWorkbenchDefaultEncoding()));
      } catch (IOException iOException) {
        try {
          if (out != null)
            out.close(); 
        } catch (IOException iOException1) {}
      } finally {
        try {
          if (out != null)
            out.close(); 
        } catch (IOException iOException) {}
      } 
    } 
  }
  
  public File getPartitionPath() {
    return this.partitionPath;
  }
  
  public void setPartitionPath(File partitionPath) {
    this.partitionPath = partitionPath;
  }
  
  public File getEmmcParitionPath() {
    return this.emmcParitionPath;
  }
  
  public void setEmmcParitionPath(File emmcParitionPath) {
    this.emmcParitionPath = emmcParitionPath;
  }
}
